local _G = _G
local tonumber = _G.tonumber
local AceLibrary = _G.AceLibrary

local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 37694 $"):match("%d+"))

if _G.ThreatLib_OUT_OF_DATE or not AceLibrary:IsNewVersion(MAJOR_VERSION, MINOR_VERSION) then
	_G.ThreatLib_OUT_OF_DATE = true
end

if not _G.ThreatLib_MINOR_VERSION or MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

-- temporary global metadata
local ThreatLib = _G.ThreatLib
_G.ThreatLib = nil
MINOR_VERSION = _G.ThreatLib_MINOR_VERSION
_G.ThreatLib_MINOR_VERSION = nil

if _G.ThreatLib_OUT_OF_DATE then
	_G.ThreatLib_OUT_OF_DATE = nil
	return
end

local UpvalueFixers = ThreatLib.UpvalueFixers
ThreatLib.UpvalueFixers = nil

-- internal variables
ThreatLib.new = nil
ThreatLib.newHash = nil
ThreatLib.newSet = nil
ThreatLib.del = nil

-- Actual registration
AceLibrary:Register(ThreatLib, MAJOR_VERSION, MINOR_VERSION)

ThreatLib = AceLibrary(MAJOR_VERSION)
for _, v in _G.ipairs(UpvalueFixers) do
	v(ThreatLib)
end


